Index: /trunk/zoo-project/zoo-kernel/service_internal.c
===================================================================
--- /trunk/zoo-project/zoo-kernel/service_internal.c	(revision 469)
+++ /trunk/zoo-project/zoo-kernel/service_internal.c	(revision 470)
@@ -2925,4 +2925,5 @@
     setMapInMaps(conf,"lenv",key,tmps2);
     free(tmps2);
+    free(test);
     level++;
     tmps1=strtok_r(NULL,".",&saveptr1);
@@ -2953,8 +2954,8 @@
       }
     }else{
-      char *tmp0=zStrdup(tmp00->value);
-      tmp0[strlen(tmp0)-1]=0;
-      setMapInMaps(conf,"lenv","Identifier",tmp0);
-      free(tmp0);
+      char *tmp01=zStrdup(tmp00->value);
+      tmp01[strlen(tmp01)-1]=0;
+      setMapInMaps(conf,"lenv","Identifier",tmp01);
+      free(tmp01);
     }
   }
Index: /trunk/zoo-project/zoo-kernel/ulinet.c
===================================================================
--- /trunk/zoo-project/zoo-kernel/ulinet.c	(revision 469)
+++ /trunk/zoo-project/zoo-kernel/ulinet.c	(revision 470)
@@ -170,23 +170,23 @@
   ret.mimeType = NULL;
 
-  ret.handle=curl_easy_init();
-
-  curl_easy_setopt(ret.handle, CURLOPT_COOKIEFILE, "ALL");
+  ret.handle=curl_share_init();
+
+  curl_share_setopt(ret.handle, CURLOPT_COOKIEFILE, "ALL");
 #ifndef TIGER
-  curl_easy_setopt(ret.handle, CURLOPT_COOKIELIST, "ALL");
-#endif
-  curl_easy_setopt(ret.handle, CURLOPT_USERAGENT, lpszAgent);
-  
-  curl_easy_setopt(ret.handle,CURLOPT_FOLLOWLOCATION,1);
-  curl_easy_setopt(ret.handle,CURLOPT_MAXREDIRS,3);
+  curl_share_setopt(ret.handle, CURLOPT_COOKIELIST, "ALL");
+#endif
+  curl_share_setopt(ret.handle, CURLOPT_USERAGENT, lpszAgent);
+  
+  curl_share_setopt(ret.handle,CURLOPT_FOLLOWLOCATION,1);
+  curl_share_setopt(ret.handle,CURLOPT_MAXREDIRS,3);
   
   header.memory=NULL;
   header.size = 0;
 
-  curl_easy_setopt(ret.handle, CURLOPT_HEADERFUNCTION, header_write_data);
-  curl_easy_setopt(ret.handle, CURLOPT_WRITEHEADER, (void *)&header);
-
-#ifdef MSG_LAF_VERBOSE
-  curl_easy_setopt(ret.handle, CURLOPT_VERBOSE, 1);
+  curl_share_setopt(ret.handle, CURLOPT_HEADERFUNCTION, header_write_data);
+  curl_share_setopt(ret.handle, CURLOPT_WRITEHEADER, (void *)&header);
+
+#ifdef MSG_LAF_VERBOSE
+  curl_share_setopt(ret.handle, CURLOPT_VERBOSE, 1);
 #endif
 
@@ -206,5 +206,5 @@
   }
   if(handle.handle)
-    curl_easy_cleanup(handle.handle);
+    curl_share_cleanup(handle.handle);
   curl_global_cleanup();
 }
@@ -222,6 +222,6 @@
     case INTERNET_FLAG_NO_CACHE_WRITE:    
       hInternet.hasCacheFile=-1;
-      curl_easy_setopt(hInternet.handle, CURLOPT_WRITEFUNCTION, write_data_into);
-      curl_easy_setopt(hInternet.handle, CURLOPT_WRITEDATA, &hInternet);
+      curl_share_setopt(hInternet.handle, CURLOPT_WRITEFUNCTION, write_data_into);
+      curl_share_setopt(hInternet.handle, CURLOPT_WRITEDATA, &hInternet);
       break;
     default:
@@ -236,6 +236,6 @@
     
       hInternet.hasCacheFile=1;
-      curl_easy_setopt(hInternet.handle, CURLOPT_WRITEFUNCTION, NULL);
-      curl_easy_setopt(hInternet.handle, CURLOPT_WRITEDATA, hInternet.file);
+      curl_share_setopt(hInternet.handle, CURLOPT_WRITEFUNCTION, NULL);
+      curl_share_setopt(hInternet.handle, CURLOPT_WRITEDATA, hInternet.file);
       hInternet.nDataLen=0;
       break;
@@ -250,16 +250,16 @@
 #endif
     //curl_easy_setopt(hInternet.handle,CURLOPT_COOKIE,lpszHeaders);
-    curl_easy_setopt(hInternet.handle,CURLOPT_POST,1);
+    curl_share_setopt(hInternet.handle,CURLOPT_POST,1);
 #ifdef ULINET_DEBUG
     fprintf(stderr,"** (%s) %d **\n",lpszHeaders,dwHeadersLength);
-    curl_easy_setopt(hInternet.handle,CURLOPT_VERBOSE,1);
-#endif
-    curl_easy_setopt(hInternet.handle,CURLOPT_POSTFIELDS,lpszHeaders);
+    curl_share_setopt(hInternet.handle,CURLOPT_VERBOSE,1);
+#endif
+    curl_share_setopt(hInternet.handle,CURLOPT_POSTFIELDS,lpszHeaders);
     //curl_easy_setopt(hInternet.handle,CURLOPT_POSTFIELDSIZE,dwHeadersLength+1);
     if(hInternet.header!=NULL)
-      curl_easy_setopt(hInternet.handle,CURLOPT_HTTPHEADER,hInternet.header);
-  }
-
-  curl_easy_setopt(hInternet.handle,CURLOPT_URL,lpszUrl);
+      curl_share_setopt(hInternet.handle,CURLOPT_HTTPHEADER,hInternet.header);
+  }
+
+  curl_share_setopt(hInternet.handle,CURLOPT_URL,lpszUrl);
   curl_easy_perform(hInternet.handle);
   curl_easy_getinfo(hInternet.handle,CURLINFO_CONTENT_TYPE,&hInternet.mimeType);
@@ -273,5 +273,5 @@
   memset(&CCookie[0],0,1024);
 #ifndef TIGER
-  curl_easy_setopt(hInternet.handle, CURLOPT_COOKIELIST, "ALL");
+  curl_share_setopt(hInternet.handle, CURLOPT_COOKIELIST, "ALL");
 #endif
   return 1;
Index: /trunk/zoo-project/zoo-kernel/ulinet.h
===================================================================
--- /trunk/zoo-project/zoo-kernel/ulinet.h	(revision 469)
+++ /trunk/zoo-project/zoo-kernel/ulinet.h	(revision 470)
@@ -64,5 +64,5 @@
 
 typedef struct {
-  CURL *handle;
+  CURLSH *handle;
   struct curl_slist *header;
   char* filename;