Index: trunk/zoo-project/zoo-kernel/service_internal.c
===================================================================
--- trunk/zoo-project/zoo-kernel/service_internal.c	(revision 477)
+++ trunk/zoo-project/zoo-kernel/service_internal.c	(revision 478)
@@ -26,4 +26,6 @@
 #ifdef USE_MS
 #include "service_internal_ms.h"
+#else
+#include "cpl_vsi.h"
 #endif
 
@@ -165,5 +167,7 @@
     i++;
   }
+#ifdef DEBUG
   fprintf(stderr,"READING STRING S %s\n",lpszBuf);
+#endif
   return (char*)lpszBuf;
 }
@@ -2940,5 +2944,5 @@
   tmpMap->value=(char*)malloc((fsize+1)*sizeof(char));
   if(tmpMap->value==NULL)
-    fprintf(stderr,"Unable to allocate memory!\n");
+    return errorException(*m, _("Unable to allocate memory."), "InternalError",NULL);
   //snprintf(tmpMap->value,(fsize+1)*sizeof(char),fcontent);
   memcpy(tmpMap->value,fcontent,(fsize+1)*sizeof(char));
@@ -2971,5 +2975,4 @@
 }
 
-#ifdef USE_MS
 char *readVSIFile(maps* conf,const char* dataSource){
     VSILFILE * fichier=VSIFOpenL(dataSource,"rb");
@@ -2989,5 +2992,4 @@
     return res1;
 }
-#endif
 
 void parseIdentifier(maps* conf,char* conf_dir,char *identifier,char* buffer){
Index: trunk/zoo-project/zoo-kernel/service_internal.h
===================================================================
--- trunk/zoo-project/zoo-kernel/service_internal.h	(revision 477)
+++ trunk/zoo-project/zoo-kernel/service_internal.h	(revision 478)
@@ -31,5 +31,4 @@
 #define TIME_SIZE 40
 
-#include "cgic.h"
 #include <libintl.h>
 #include <locale.h>
@@ -39,4 +38,5 @@
 #include <sys/stat.h>
 #include <sys/types.h>
+#include "cgic.h"
 #ifndef WIN32
 #include <sys/ipc.h>
@@ -145,7 +145,5 @@
   int loadRemoteFile(maps**,map**,HINTERNET,char*);
 
-#ifdef USE_MS
   char *readVSIFile(maps*,const char*);
-#endif
   void parseIdentifier(maps*,char*,char*,char*);
   int updateStatus( maps*,const int,const char*);
Index: trunk/zoo-project/zoo-kernel/service_internal_python.c
===================================================================
--- trunk/zoo-project/zoo-kernel/service_internal_python.c	(revision 477)
+++ trunk/zoo-project/zoo-kernel/service_internal_python.c	(revision 478)
@@ -285,9 +285,8 @@
     PyErr_Clear();
     res=-1;
-    //exit(-1);
   } 
 #if PY_MAJOR_VERSION < 3
   PyGILState_Release(gstate);
-  PyEval_ReleaseLock();
+  PyEval_AcquireLock();
 #endif
   PyThreadState_Swap(mainstate);
Index: trunk/zoo-project/zoo-kernel/ulinet.c
===================================================================
--- trunk/zoo-project/zoo-kernel/ulinet.c	(revision 477)
+++ trunk/zoo-project/zoo-kernel/ulinet.c	(revision 478)
@@ -229,5 +229,4 @@
       sprintf(filename,"/tmp/ZOO_Cache%d",(int)time(NULL));
       filename[24]=0;
-      fprintf(stderr,"file=%s",filename);
 #ifdef MSG_LAF_VERBOSE
       fprintf(stderr,"file=%s",filename);
@@ -267,4 +266,5 @@
 #ifdef ULINET_DEBUG
   fprintf(stderr,"DEBUG MIMETYPE: %s\n",hInternet.mimeType);
+  fflush(stderr);
 #endif
   return hInternet;
Index: trunk/zoo-project/zoo-kernel/zoo_service_loader.c
===================================================================
--- trunk/zoo-project/zoo-kernel/zoo_service_loader.c	(revision 477)
+++ trunk/zoo-project/zoo-kernel/zoo_service_loader.c	(revision 478)
@@ -297,5 +297,7 @@
 
 void donothing(int sig){
+#ifdef DEBUG
   fprintf(stderr,"Signal %d after the ZOO-Kernel returned result !\n",sig);
+#endif
   exit(0);
 }
@@ -376,8 +378,10 @@
     DWORD errstr;
     errstr = GetLastError();
-    fprintf(stderr,"%s loaded (%d) \n",tmps1,errstr);
 #else
     char *errstr;
     errstr = dlerror();
+#endif
+#ifdef DEBUG
+    fprintf(stderr,"%s loaded (%d) \n",tmps1,errstr);
 #endif
     if( so != NULL ) {
@@ -461,5 +465,7 @@
 	  errorException(m, tmpMsg, "InternalError",NULL);
 	  free(tmpMsg);
+#ifdef DEBUG
 	  fprintf(stderr,"Function %s error %s\n",r_inputs->value,errstr);
+#endif
 	  return;
 	}
Index: trunk/zoo-project/zoo-services/utils/status/makefile.vc
===================================================================
--- trunk/zoo-project/zoo-services/utils/status/makefile.vc	(revision 477)
+++ trunk/zoo-project/zoo-services/utils/status/makefile.vc	(revision 478)
@@ -2,5 +2,5 @@
 !INCLUDE $(ZOOK_DIR)/nmake.opt
 
-FILES=$(ZOOK_DIR)/dirent.obj $(ZOOK_DIR)/service_internal.obj $(ZOOK_DIR)/ulinet.obj
+FILES=$(ZOOK_DIR)/service_internal.obj $(ZOOK_DIR)/ulinet.obj
 !IFDEF JS_DIR
 FILES=$(FILES) $(ZOOK_DIR)$(JS_FILE)
Index: trunk/zoo-project/zoo-services/utils/status/service.c
===================================================================
--- trunk/zoo-project/zoo-services/utils/status/service.c	(revision 477)
+++ trunk/zoo-project/zoo-services/utils/status/service.c	(revision 478)
@@ -104,5 +104,7 @@
        */
       char *tmpStr=getStatus(atoi(tmpMap->value));
+#ifdef DEBUG
       fprintf(stderr,"DEBUG: %s \n",tmpStr);
+#endif
       if(tmpStr!=NULL && strncmp(tmpStr,"-1",2)!=0){
 	char *tmpStr1=strdup(tmpStr);